clear all   % Rensa alla variabler i arbetsminnet/workspace
figure(1)   % ppna/aktivera figur 1
clf         % Rensa fnstret, om det ev. inte var tomt


% Matlabfunktionen imread anvnds fr att ladda in en bild till arbetsminnet.
% Digitala frgbilder representeras i Matlab som 3-dimensionella matriser,
% (rad x kolumn x kanal). Oftast r det 3 kanaler - Rd, Grn och Bl.
I = imread('peppers.png');


% Matlabfunktionen imshow anvnds fr att visa/rita bilder.
% Nu ritas frst den uppladdade bilden.
figure(1); 
subplot(2,2,1)
imshow(I);
title('RGB-bild')


% Tag fram bildens dimensioner
rader    = size(I,1);
kolumner = size(I,2);


% Nu ska den 3-kanaliga frgbilden konverteras till en 1-kanals grskalebild.
% Vid Konverteringen frn frg till grskala s kan de tre frgerna skalas
% med olika skalningskonstanter. 
% HR FINNS DET FRSTA FELET! VAR SKER FELET? KORRIGERA FELET!
% (ndra inte skalningskonstanterna - de r korrekta!)
I_g = [];
for i=1:rader
    for j=1:kolumner
        I_g(j,i)=0.2126*I(i,j,1)+0.7152*I(i,j,2)+0.0722*I(i,j,3);
    end
end


% Nu ska ven grskalebilden ritas i Matlabfnstret.
% Vrdena inom hakparanteser anger grskalekanalens minsta resp. hgsta vrde.
subplot(2,2,2)
imshow(I_g,[0 255]);
title('Grskalebild')


% Lgg p lite brus p bilden, genom att vrdet p varje pixel justeras
% slumpmssigt en aning. Vi adderar ett gaussiskt brus till bilden.
% HR FINNS DET ANDRA FELET! VAR SKER FELET? KORRIGERA FELET!
I_n = imnoise(uint8(I_g'),'gaussian',0,0.01);


% Rita den brusiga grskalebilden
subplot(2,2,3)
imshow(I_n);
title('Brusig grskalebild')


% I nsta steg ska vi ta fram sjlva bruset, genom att subtrahera 
% grskalebilden frn den brusiga bilden: (bild + brus) - bild = brus.
% I stllet fr att subtrahera hela bilderna (matriserna) direkt 
% (som man naturligtvis *ska* gra fr att vara effektiv), s ska vi
% som vning utfra subtraktionen pixel fr pixel:
Brus = zeros(rader,kolumner);   % Initiera frst Brus-matrisen,  
                                % som kommer att innehlla bildbruset. 

% HR NEDAN FINNS DE TERSTENDE FELEN!      OBS: DET R FLERA FEL!
% VAR SKER FELEN? KORRIGERA DEM!                                
i = 1;
% Fr "skojs" skull anvnder vi while-loopar i stller fr for-loopar!  :)
while i <= rader
    while k <= kolumner
        Brus(i,kolumner) = I_n(i, k) - I_g(i, k);
        i=i+1;
    end 
end


% Rita bilden med enbart bruset
subplot(2,2,4) 
imshow(Brus,[-128, 127]);
title('Brus')
